// Copyright (c) 2005-2017 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include "OpenDocument_manifest_v1_2.hxx"

namespace digidoc
{
  namespace manifest_1_2
  {
    // Base64Binary
    // 


    // NamespacedToken
    // 


    // NonNegativeInteger
    // 


    // String
    // 


    // AnyURI
    // 


    // Manifest
    // 

    const Manifest::File_entrySequence& Manifest::
    file_entry () const
    {
      return this->file_entry_;
    }

    Manifest::File_entrySequence& Manifest::
    file_entry ()
    {
      return this->file_entry_;
    }

    void Manifest::
    file_entry (const File_entrySequence& s)
    {
      this->file_entry_ = s;
    }

    const Manifest::VersionType& Manifest::
    version () const
    {
      return this->version_.get ();
    }

    Manifest::VersionType& Manifest::
    version ()
    {
      return this->version_.get ();
    }

    void Manifest::
    version (const VersionType& x)
    {
      this->version_.set (x);
    }

    void Manifest::
    version (::std::unique_ptr< VersionType > x)
    {
      this->version_.set (std::move (x));
    }


    // Version
    // 

    Version::
    Version (Value v)
    : ::xml_schema::Token (_xsd_Version_literals_[v])
    {
    }

    Version::
    Version (const char* v)
    : ::xml_schema::Token (v)
    {
    }

    Version::
    Version (const ::std::string& v)
    : ::xml_schema::Token (v)
    {
    }

    Version::
    Version (const ::xml_schema::Token& v)
    : ::xml_schema::Token (v)
    {
    }

    Version::
    Version (const Version& v,
             ::xml_schema::Flags f,
             ::xml_schema::Container* c)
    : ::xml_schema::Token (v, f, c)
    {
    }

    Version& Version::
    operator= (Value v)
    {
      static_cast< ::xml_schema::Token& > (*this) = 
      ::xml_schema::Token (_xsd_Version_literals_[v]);

      return *this;
    }


    // File_entry
    // 

    const File_entry::Encryption_dataOptional& File_entry::
    encryption_data () const
    {
      return this->encryption_data_;
    }

    File_entry::Encryption_dataOptional& File_entry::
    encryption_data ()
    {
      return this->encryption_data_;
    }

    void File_entry::
    encryption_data (const Encryption_dataType& x)
    {
      this->encryption_data_.set (x);
    }

    void File_entry::
    encryption_data (const Encryption_dataOptional& x)
    {
      this->encryption_data_ = x;
    }

    void File_entry::
    encryption_data (::std::unique_ptr< Encryption_dataType > x)
    {
      this->encryption_data_.set (std::move (x));
    }

    const File_entry::Full_pathType& File_entry::
    full_path () const
    {
      return this->full_path_.get ();
    }

    File_entry::Full_pathType& File_entry::
    full_path ()
    {
      return this->full_path_.get ();
    }

    void File_entry::
    full_path (const Full_pathType& x)
    {
      this->full_path_.set (x);
    }

    void File_entry::
    full_path (::std::unique_ptr< Full_pathType > x)
    {
      this->full_path_.set (std::move (x));
    }

    const File_entry::SizeOptional& File_entry::
    size () const
    {
      return this->size_;
    }

    File_entry::SizeOptional& File_entry::
    size ()
    {
      return this->size_;
    }

    void File_entry::
    size (const SizeType& x)
    {
      this->size_.set (x);
    }

    void File_entry::
    size (const SizeOptional& x)
    {
      this->size_ = x;
    }

    void File_entry::
    size (::std::unique_ptr< SizeType > x)
    {
      this->size_.set (std::move (x));
    }

    const File_entry::Media_typeType& File_entry::
    media_type () const
    {
      return this->media_type_.get ();
    }

    File_entry::Media_typeType& File_entry::
    media_type ()
    {
      return this->media_type_.get ();
    }

    void File_entry::
    media_type (const Media_typeType& x)
    {
      this->media_type_.set (x);
    }

    void File_entry::
    media_type (::std::unique_ptr< Media_typeType > x)
    {
      this->media_type_.set (std::move (x));
    }

    const File_entry::Preferred_view_modeOptional& File_entry::
    preferred_view_mode () const
    {
      return this->preferred_view_mode_;
    }

    File_entry::Preferred_view_modeOptional& File_entry::
    preferred_view_mode ()
    {
      return this->preferred_view_mode_;
    }

    void File_entry::
    preferred_view_mode (const Preferred_view_modeType& x)
    {
      this->preferred_view_mode_.set (x);
    }

    void File_entry::
    preferred_view_mode (const Preferred_view_modeOptional& x)
    {
      this->preferred_view_mode_ = x;
    }

    void File_entry::
    preferred_view_mode (::std::unique_ptr< Preferred_view_modeType > x)
    {
      this->preferred_view_mode_.set (std::move (x));
    }

    const File_entry::VersionOptional& File_entry::
    version () const
    {
      return this->version_;
    }

    File_entry::VersionOptional& File_entry::
    version ()
    {
      return this->version_;
    }

    void File_entry::
    version (const VersionType& x)
    {
      this->version_.set (x);
    }

    void File_entry::
    version (const VersionOptional& x)
    {
      this->version_ = x;
    }

    void File_entry::
    version (::std::unique_ptr< VersionType > x)
    {
      this->version_.set (std::move (x));
    }


    // Preferred_view_mode
    //

    Preferred_view_mode::
    Preferred_view_mode (const char* s)
    : ::xml_schema::String (s)
    {
    }

    Preferred_view_mode::
    Preferred_view_mode (const ::std::string& s)
    : ::xml_schema::String (s)
    {
    }

    Preferred_view_mode::
    Preferred_view_mode (const Preferred_view_mode& o,
                         ::xml_schema::Flags f,
                         ::xml_schema::Container* c)
    : ::xml_schema::String (o, f, c)
    {
    }

    // Encryption_data
    // 

    const Encryption_data::AlgorithmType& Encryption_data::
    algorithm () const
    {
      return this->algorithm_.get ();
    }

    Encryption_data::AlgorithmType& Encryption_data::
    algorithm ()
    {
      return this->algorithm_.get ();
    }

    void Encryption_data::
    algorithm (const AlgorithmType& x)
    {
      this->algorithm_.set (x);
    }

    void Encryption_data::
    algorithm (::std::unique_ptr< AlgorithmType > x)
    {
      this->algorithm_.set (std::move (x));
    }

    const Encryption_data::Start_key_generationOptional& Encryption_data::
    start_key_generation () const
    {
      return this->start_key_generation_;
    }

    Encryption_data::Start_key_generationOptional& Encryption_data::
    start_key_generation ()
    {
      return this->start_key_generation_;
    }

    void Encryption_data::
    start_key_generation (const Start_key_generationType& x)
    {
      this->start_key_generation_.set (x);
    }

    void Encryption_data::
    start_key_generation (const Start_key_generationOptional& x)
    {
      this->start_key_generation_ = x;
    }

    void Encryption_data::
    start_key_generation (::std::unique_ptr< Start_key_generationType > x)
    {
      this->start_key_generation_.set (std::move (x));
    }

    const Encryption_data::Key_derivationType& Encryption_data::
    key_derivation () const
    {
      return this->key_derivation_.get ();
    }

    Encryption_data::Key_derivationType& Encryption_data::
    key_derivation ()
    {
      return this->key_derivation_.get ();
    }

    void Encryption_data::
    key_derivation (const Key_derivationType& x)
    {
      this->key_derivation_.set (x);
    }

    void Encryption_data::
    key_derivation (::std::unique_ptr< Key_derivationType > x)
    {
      this->key_derivation_.set (std::move (x));
    }

    const Encryption_data::Checksum_typeType& Encryption_data::
    checksum_type () const
    {
      return this->checksum_type_.get ();
    }

    Encryption_data::Checksum_typeType& Encryption_data::
    checksum_type ()
    {
      return this->checksum_type_.get ();
    }

    void Encryption_data::
    checksum_type (const Checksum_typeType& x)
    {
      this->checksum_type_.set (x);
    }

    void Encryption_data::
    checksum_type (::std::unique_ptr< Checksum_typeType > x)
    {
      this->checksum_type_.set (std::move (x));
    }

    const Encryption_data::ChecksumType& Encryption_data::
    checksum () const
    {
      return this->checksum_.get ();
    }

    Encryption_data::ChecksumType& Encryption_data::
    checksum ()
    {
      return this->checksum_.get ();
    }

    void Encryption_data::
    checksum (const ChecksumType& x)
    {
      this->checksum_.set (x);
    }

    void Encryption_data::
    checksum (::std::unique_ptr< ChecksumType > x)
    {
      this->checksum_.set (std::move (x));
    }


    // Checksum_type
    //

    Checksum_type::
    Checksum_type (const char* s)
    : ::xml_schema::String (s)
    {
    }

    Checksum_type::
    Checksum_type (const ::std::string& s)
    : ::xml_schema::String (s)
    {
    }

    Checksum_type::
    Checksum_type (const Checksum_type& o,
                   ::xml_schema::Flags f,
                   ::xml_schema::Container* c)
    : ::xml_schema::String (o, f, c)
    {
    }

    // Algorithm
    // 

    const Algorithm::Algorithm_nameType& Algorithm::
    algorithm_name () const
    {
      return this->algorithm_name_.get ();
    }

    Algorithm::Algorithm_nameType& Algorithm::
    algorithm_name ()
    {
      return this->algorithm_name_.get ();
    }

    void Algorithm::
    algorithm_name (const Algorithm_nameType& x)
    {
      this->algorithm_name_.set (x);
    }

    void Algorithm::
    algorithm_name (::std::unique_ptr< Algorithm_nameType > x)
    {
      this->algorithm_name_.set (std::move (x));
    }

    const Algorithm::Initialisation_vectorType& Algorithm::
    initialisation_vector () const
    {
      return this->initialisation_vector_.get ();
    }

    Algorithm::Initialisation_vectorType& Algorithm::
    initialisation_vector ()
    {
      return this->initialisation_vector_.get ();
    }

    void Algorithm::
    initialisation_vector (const Initialisation_vectorType& x)
    {
      this->initialisation_vector_.set (x);
    }

    void Algorithm::
    initialisation_vector (::std::unique_ptr< Initialisation_vectorType > x)
    {
      this->initialisation_vector_.set (std::move (x));
    }


    // Algorithm_name
    //

    Algorithm_name::
    Algorithm_name (const char* s)
    : ::xml_schema::String (s)
    {
    }

    Algorithm_name::
    Algorithm_name (const ::std::string& s)
    : ::xml_schema::String (s)
    {
    }

    Algorithm_name::
    Algorithm_name (const Algorithm_name& o,
                    ::xml_schema::Flags f,
                    ::xml_schema::Container* c)
    : ::xml_schema::String (o, f, c)
    {
    }

    // Key_derivation
    // 

    const Key_derivation::Key_derivation_nameType& Key_derivation::
    key_derivation_name () const
    {
      return this->key_derivation_name_.get ();
    }

    Key_derivation::Key_derivation_nameType& Key_derivation::
    key_derivation_name ()
    {
      return this->key_derivation_name_.get ();
    }

    void Key_derivation::
    key_derivation_name (const Key_derivation_nameType& x)
    {
      this->key_derivation_name_.set (x);
    }

    void Key_derivation::
    key_derivation_name (::std::unique_ptr< Key_derivation_nameType > x)
    {
      this->key_derivation_name_.set (std::move (x));
    }

    const Key_derivation::SaltType& Key_derivation::
    salt () const
    {
      return this->salt_.get ();
    }

    Key_derivation::SaltType& Key_derivation::
    salt ()
    {
      return this->salt_.get ();
    }

    void Key_derivation::
    salt (const SaltType& x)
    {
      this->salt_.set (x);
    }

    void Key_derivation::
    salt (::std::unique_ptr< SaltType > x)
    {
      this->salt_.set (std::move (x));
    }

    const Key_derivation::Iteration_countType& Key_derivation::
    iteration_count () const
    {
      return this->iteration_count_.get ();
    }

    Key_derivation::Iteration_countType& Key_derivation::
    iteration_count ()
    {
      return this->iteration_count_.get ();
    }

    void Key_derivation::
    iteration_count (const Iteration_countType& x)
    {
      this->iteration_count_.set (x);
    }

    void Key_derivation::
    iteration_count (::std::unique_ptr< Iteration_countType > x)
    {
      this->iteration_count_.set (std::move (x));
    }

    const Key_derivation::Key_sizeOptional& Key_derivation::
    key_size () const
    {
      return this->key_size_;
    }

    Key_derivation::Key_sizeOptional& Key_derivation::
    key_size ()
    {
      return this->key_size_;
    }

    void Key_derivation::
    key_size (const Key_sizeType& x)
    {
      this->key_size_.set (x);
    }

    void Key_derivation::
    key_size (const Key_sizeOptional& x)
    {
      this->key_size_ = x;
    }

    void Key_derivation::
    key_size (::std::unique_ptr< Key_sizeType > x)
    {
      this->key_size_.set (std::move (x));
    }


    // Key_derivation_name
    //

    Key_derivation_name::
    Key_derivation_name (const char* s)
    : ::xml_schema::String (s)
    {
    }

    Key_derivation_name::
    Key_derivation_name (const ::std::string& s)
    : ::xml_schema::String (s)
    {
    }

    Key_derivation_name::
    Key_derivation_name (const Key_derivation_name& o,
                         ::xml_schema::Flags f,
                         ::xml_schema::Container* c)
    : ::xml_schema::String (o, f, c)
    {
    }

    // Start_key_generation
    // 

    const Start_key_generation::Start_key_generation_nameType& Start_key_generation::
    start_key_generation_name () const
    {
      return this->start_key_generation_name_.get ();
    }

    Start_key_generation::Start_key_generation_nameType& Start_key_generation::
    start_key_generation_name ()
    {
      return this->start_key_generation_name_.get ();
    }

    void Start_key_generation::
    start_key_generation_name (const Start_key_generation_nameType& x)
    {
      this->start_key_generation_name_.set (x);
    }

    void Start_key_generation::
    start_key_generation_name (::std::unique_ptr< Start_key_generation_nameType > x)
    {
      this->start_key_generation_name_.set (std::move (x));
    }

    const Start_key_generation::Key_sizeOptional& Start_key_generation::
    key_size () const
    {
      return this->key_size_;
    }

    Start_key_generation::Key_sizeOptional& Start_key_generation::
    key_size ()
    {
      return this->key_size_;
    }

    void Start_key_generation::
    key_size (const Key_sizeType& x)
    {
      this->key_size_.set (x);
    }

    void Start_key_generation::
    key_size (const Key_sizeOptional& x)
    {
      this->key_size_ = x;
    }

    void Start_key_generation::
    key_size (::std::unique_ptr< Key_sizeType > x)
    {
      this->key_size_.set (std::move (x));
    }


    // Start_key_generation_name
    //

    Start_key_generation_name::
    Start_key_generation_name (const char* s)
    : ::xml_schema::String (s)
    {
    }

    Start_key_generation_name::
    Start_key_generation_name (const ::std::string& s)
    : ::xml_schema::String (s)
    {
    }

    Start_key_generation_name::
    Start_key_generation_name (const Start_key_generation_name& o,
                               ::xml_schema::Flags f,
                               ::xml_schema::Container* c)
    : ::xml_schema::String (o, f, c)
    {
    }

    // Preferred_view_mode_member
    // 

    Preferred_view_mode_member::
    Preferred_view_mode_member (Value v)
    : ::xml_schema::Token (_xsd_Preferred_view_mode_member_literals_[v])
    {
    }

    Preferred_view_mode_member::
    Preferred_view_mode_member (const char* v)
    : ::xml_schema::Token (v)
    {
    }

    Preferred_view_mode_member::
    Preferred_view_mode_member (const ::std::string& v)
    : ::xml_schema::Token (v)
    {
    }

    Preferred_view_mode_member::
    Preferred_view_mode_member (const ::xml_schema::Token& v)
    : ::xml_schema::Token (v)
    {
    }

    Preferred_view_mode_member::
    Preferred_view_mode_member (const Preferred_view_mode_member& v,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Token (v, f, c)
    {
    }

    Preferred_view_mode_member& Preferred_view_mode_member::
    operator= (Value v)
    {
      static_cast< ::xml_schema::Token& > (*this) = 
      ::xml_schema::Token (_xsd_Preferred_view_mode_member_literals_[v]);

      return *this;
    }


    // Preferred_view_mode_member1
    // 

    Preferred_view_mode_member1::
    Preferred_view_mode_member1 (Value v)
    : ::xml_schema::Token (_xsd_Preferred_view_mode_member1_literals_[v])
    {
    }

    Preferred_view_mode_member1::
    Preferred_view_mode_member1 (const char* v)
    : ::xml_schema::Token (v)
    {
    }

    Preferred_view_mode_member1::
    Preferred_view_mode_member1 (const ::std::string& v)
    : ::xml_schema::Token (v)
    {
    }

    Preferred_view_mode_member1::
    Preferred_view_mode_member1 (const ::xml_schema::Token& v)
    : ::xml_schema::Token (v)
    {
    }

    Preferred_view_mode_member1::
    Preferred_view_mode_member1 (const Preferred_view_mode_member1& v,
                                 ::xml_schema::Flags f,
                                 ::xml_schema::Container* c)
    : ::xml_schema::Token (v, f, c)
    {
    }

    Preferred_view_mode_member1& Preferred_view_mode_member1::
    operator= (Value v)
    {
      static_cast< ::xml_schema::Token& > (*this) = 
      ::xml_schema::Token (_xsd_Preferred_view_mode_member1_literals_[v]);

      return *this;
    }


    // Preferred_view_mode_member2
    // 

    Preferred_view_mode_member2::
    Preferred_view_mode_member2 (Value v)
    : ::xml_schema::Token (_xsd_Preferred_view_mode_member2_literals_[v])
    {
    }

    Preferred_view_mode_member2::
    Preferred_view_mode_member2 (const char* v)
    : ::xml_schema::Token (v)
    {
    }

    Preferred_view_mode_member2::
    Preferred_view_mode_member2 (const ::std::string& v)
    : ::xml_schema::Token (v)
    {
    }

    Preferred_view_mode_member2::
    Preferred_view_mode_member2 (const ::xml_schema::Token& v)
    : ::xml_schema::Token (v)
    {
    }

    Preferred_view_mode_member2::
    Preferred_view_mode_member2 (const Preferred_view_mode_member2& v,
                                 ::xml_schema::Flags f,
                                 ::xml_schema::Container* c)
    : ::xml_schema::Token (v, f, c)
    {
    }

    Preferred_view_mode_member2& Preferred_view_mode_member2::
    operator= (Value v)
    {
      static_cast< ::xml_schema::Token& > (*this) = 
      ::xml_schema::Token (_xsd_Preferred_view_mode_member2_literals_[v]);

      return *this;
    }


    // Checksum_type_member
    // 

    Checksum_type_member::
    Checksum_type_member (Value v)
    : ::xml_schema::Token (_xsd_Checksum_type_member_literals_[v])
    {
    }

    Checksum_type_member::
    Checksum_type_member (const char* v)
    : ::xml_schema::Token (v)
    {
    }

    Checksum_type_member::
    Checksum_type_member (const ::std::string& v)
    : ::xml_schema::Token (v)
    {
    }

    Checksum_type_member::
    Checksum_type_member (const ::xml_schema::Token& v)
    : ::xml_schema::Token (v)
    {
    }

    Checksum_type_member::
    Checksum_type_member (const Checksum_type_member& v,
                          ::xml_schema::Flags f,
                          ::xml_schema::Container* c)
    : ::xml_schema::Token (v, f, c)
    {
    }

    Checksum_type_member& Checksum_type_member::
    operator= (Value v)
    {
      static_cast< ::xml_schema::Token& > (*this) = 
      ::xml_schema::Token (_xsd_Checksum_type_member_literals_[v]);

      return *this;
    }


    // Algorithm_name_member
    // 

    Algorithm_name_member::
    Algorithm_name_member (Value v)
    : ::xml_schema::Token (_xsd_Algorithm_name_member_literals_[v])
    {
    }

    Algorithm_name_member::
    Algorithm_name_member (const char* v)
    : ::xml_schema::Token (v)
    {
    }

    Algorithm_name_member::
    Algorithm_name_member (const ::std::string& v)
    : ::xml_schema::Token (v)
    {
    }

    Algorithm_name_member::
    Algorithm_name_member (const ::xml_schema::Token& v)
    : ::xml_schema::Token (v)
    {
    }

    Algorithm_name_member::
    Algorithm_name_member (const Algorithm_name_member& v,
                           ::xml_schema::Flags f,
                           ::xml_schema::Container* c)
    : ::xml_schema::Token (v, f, c)
    {
    }

    Algorithm_name_member& Algorithm_name_member::
    operator= (Value v)
    {
      static_cast< ::xml_schema::Token& > (*this) = 
      ::xml_schema::Token (_xsd_Algorithm_name_member_literals_[v]);

      return *this;
    }


    // Key_derivation_name_member
    // 

    Key_derivation_name_member::
    Key_derivation_name_member (Value v)
    : ::xml_schema::Token (_xsd_Key_derivation_name_member_literals_[v])
    {
    }

    Key_derivation_name_member::
    Key_derivation_name_member (const char* v)
    : ::xml_schema::Token (v)
    {
    }

    Key_derivation_name_member::
    Key_derivation_name_member (const ::std::string& v)
    : ::xml_schema::Token (v)
    {
    }

    Key_derivation_name_member::
    Key_derivation_name_member (const ::xml_schema::Token& v)
    : ::xml_schema::Token (v)
    {
    }

    Key_derivation_name_member::
    Key_derivation_name_member (const Key_derivation_name_member& v,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Token (v, f, c)
    {
    }

    Key_derivation_name_member& Key_derivation_name_member::
    operator= (Value v)
    {
      static_cast< ::xml_schema::Token& > (*this) = 
      ::xml_schema::Token (_xsd_Key_derivation_name_member_literals_[v]);

      return *this;
    }


    // Start_key_generation_name_member
    // 

    Start_key_generation_name_member::
    Start_key_generation_name_member (Value v)
    : ::xml_schema::Token (_xsd_Start_key_generation_name_member_literals_[v])
    {
    }

    Start_key_generation_name_member::
    Start_key_generation_name_member (const char* v)
    : ::xml_schema::Token (v)
    {
    }

    Start_key_generation_name_member::
    Start_key_generation_name_member (const ::std::string& v)
    : ::xml_schema::Token (v)
    {
    }

    Start_key_generation_name_member::
    Start_key_generation_name_member (const ::xml_schema::Token& v)
    : ::xml_schema::Token (v)
    {
    }

    Start_key_generation_name_member::
    Start_key_generation_name_member (const Start_key_generation_name_member& v,
                                      ::xml_schema::Flags f,
                                      ::xml_schema::Container* c)
    : ::xml_schema::Token (v, f, c)
    {
    }

    Start_key_generation_name_member& Start_key_generation_name_member::
    operator= (Value v)
    {
      static_cast< ::xml_schema::Token& > (*this) = 
      ::xml_schema::Token (_xsd_Start_key_generation_name_member_literals_[v]);

      return *this;
    }
  }
}

#include <xsd/cxx/xml/dom/parsing-source.hxx>

namespace digidoc
{
  namespace manifest_1_2
  {
    // Base64Binary
    //

    Base64Binary::
    Base64Binary ()
    : ::xml_schema::Base64Binary ()
    {
    }

    Base64Binary::
    Base64Binary (const ::xml_schema::Base64Binary& _xsd_Base64Binary_base)
    : ::xml_schema::Base64Binary (_xsd_Base64Binary_base)
    {
    }

    Base64Binary::
    Base64Binary (const Base64Binary& x,
                  ::xml_schema::Flags f,
                  ::xml_schema::Container* c)
    : ::xml_schema::Base64Binary (x, f, c)
    {
    }

    Base64Binary::
    Base64Binary (const ::xercesc::DOMElement& e,
                  ::xml_schema::Flags f,
                  ::xml_schema::Container* c)
    : ::xml_schema::Base64Binary (e, f, c)
    {
    }

    Base64Binary::
    Base64Binary (const ::xercesc::DOMAttr& a,
                  ::xml_schema::Flags f,
                  ::xml_schema::Container* c)
    : ::xml_schema::Base64Binary (a, f, c)
    {
    }

    Base64Binary::
    Base64Binary (const ::std::string& s,
                  const ::xercesc::DOMElement* e,
                  ::xml_schema::Flags f,
                  ::xml_schema::Container* c)
    : ::xml_schema::Base64Binary (s, e, f, c)
    {
    }

    Base64Binary* Base64Binary::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Base64Binary (*this, f, c);
    }

    Base64Binary::
    ~Base64Binary ()
    {
    }

    // NamespacedToken
    //

    NamespacedToken::
    NamespacedToken (const ::xml_schema::Qname& _xsd_Qname_base)
    : ::xml_schema::Qname (_xsd_Qname_base)
    {
    }

    NamespacedToken::
    NamespacedToken (const NamespacedToken& x,
                     ::xml_schema::Flags f,
                     ::xml_schema::Container* c)
    : ::xml_schema::Qname (x, f, c)
    {
    }

    NamespacedToken::
    NamespacedToken (const ::xercesc::DOMElement& e,
                     ::xml_schema::Flags f,
                     ::xml_schema::Container* c)
    : ::xml_schema::Qname (e, f, c)
    {
    }

    NamespacedToken::
    NamespacedToken (const ::xercesc::DOMAttr& a,
                     ::xml_schema::Flags f,
                     ::xml_schema::Container* c)
    : ::xml_schema::Qname (a, f, c)
    {
    }

    NamespacedToken::
    NamespacedToken (const ::std::string& s,
                     const ::xercesc::DOMElement* e,
                     ::xml_schema::Flags f,
                     ::xml_schema::Container* c)
    : ::xml_schema::Qname (s, e, f, c)
    {
    }

    NamespacedToken* NamespacedToken::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class NamespacedToken (*this, f, c);
    }

    NamespacedToken::
    ~NamespacedToken ()
    {
    }

    // NonNegativeInteger
    //

    NonNegativeInteger::
    NonNegativeInteger (const ::xml_schema::NonNegativeInteger& _xsd_NonNegativeInteger_base)
    : ::xsd::cxx::tree::fundamental_base< ::xml_schema::NonNegativeInteger, char, ::xml_schema::SimpleType > (_xsd_NonNegativeInteger_base)
    {
    }

    NonNegativeInteger::
    NonNegativeInteger (const NonNegativeInteger& x,
                        ::xml_schema::Flags f,
                        ::xml_schema::Container* c)
    : ::xsd::cxx::tree::fundamental_base< ::xml_schema::NonNegativeInteger, char, ::xml_schema::SimpleType > (x, f, c)
    {
    }

    NonNegativeInteger::
    NonNegativeInteger (const ::xercesc::DOMElement& e,
                        ::xml_schema::Flags f,
                        ::xml_schema::Container* c)
    : ::xsd::cxx::tree::fundamental_base< ::xml_schema::NonNegativeInteger, char, ::xml_schema::SimpleType > (e, f, c)
    {
    }

    NonNegativeInteger::
    NonNegativeInteger (const ::xercesc::DOMAttr& a,
                        ::xml_schema::Flags f,
                        ::xml_schema::Container* c)
    : ::xsd::cxx::tree::fundamental_base< ::xml_schema::NonNegativeInteger, char, ::xml_schema::SimpleType > (a, f, c)
    {
    }

    NonNegativeInteger::
    NonNegativeInteger (const ::std::string& s,
                        const ::xercesc::DOMElement* e,
                        ::xml_schema::Flags f,
                        ::xml_schema::Container* c)
    : ::xsd::cxx::tree::fundamental_base< ::xml_schema::NonNegativeInteger, char, ::xml_schema::SimpleType > (s, e, f, c)
    {
    }

    NonNegativeInteger* NonNegativeInteger::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class NonNegativeInteger (*this, f, c);
    }

    NonNegativeInteger::
    ~NonNegativeInteger ()
    {
    }

    // String
    //

    String::
    String ()
    : ::xml_schema::String ()
    {
    }

    String::
    String (const char* _xsd_String_base)
    : ::xml_schema::String (_xsd_String_base)
    {
    }

    String::
    String (const ::std::string& _xsd_String_base)
    : ::xml_schema::String (_xsd_String_base)
    {
    }

    String::
    String (const ::xml_schema::String& _xsd_String_base)
    : ::xml_schema::String (_xsd_String_base)
    {
    }

    String::
    String (const String& x,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::String (x, f, c)
    {
    }

    String::
    String (const ::xercesc::DOMElement& e,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::String (e, f, c)
    {
    }

    String::
    String (const ::xercesc::DOMAttr& a,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::String (a, f, c)
    {
    }

    String::
    String (const ::std::string& s,
            const ::xercesc::DOMElement* e,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::String (s, e, f, c)
    {
    }

    String* String::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class String (*this, f, c);
    }

    String::
    ~String ()
    {
    }

    // AnyURI
    //

    AnyURI::
    AnyURI (const ::xml_schema::Uri& _xsd_Uri_base)
    : ::xml_schema::Uri (_xsd_Uri_base)
    {
    }

    AnyURI::
    AnyURI (const AnyURI& x,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::Uri (x, f, c)
    {
    }

    AnyURI::
    AnyURI (const ::xercesc::DOMElement& e,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::Uri (e, f, c)
    {
    }

    AnyURI::
    AnyURI (const ::xercesc::DOMAttr& a,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::Uri (a, f, c)
    {
    }

    AnyURI::
    AnyURI (const ::std::string& s,
            const ::xercesc::DOMElement* e,
            ::xml_schema::Flags f,
            ::xml_schema::Container* c)
    : ::xml_schema::Uri (s, e, f, c)
    {
    }

    AnyURI* AnyURI::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class AnyURI (*this, f, c);
    }

    AnyURI::
    ~AnyURI ()
    {
    }

    // Manifest
    //

    Manifest::
    Manifest (const VersionType& version)
    : ::xml_schema::Type (),
      file_entry_ (this),
      version_ (version, this)
    {
    }

    Manifest::
    Manifest (const Manifest& x,
              ::xml_schema::Flags f,
              ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      file_entry_ (x.file_entry_, f, this),
      version_ (x.version_, f, this)
    {
    }

    Manifest::
    Manifest (const ::xercesc::DOMElement& e,
              ::xml_schema::Flags f,
              ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      file_entry_ (this),
      version_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
        this->parse (p, f);
      }
    }

    void Manifest::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // file-entry
        //
        if (n.name () == "file-entry" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          ::std::unique_ptr< File_entryType > r (
            File_entryTraits::create (i, f, this));

          this->file_entry_.push_back (::std::move (r));
          continue;
        }

        break;
      }

      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "version" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->version_.set (VersionTraits::create (i, f, this));
          continue;
        }
      }

      if (!version_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "version",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }
    }

    Manifest* Manifest::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Manifest (*this, f, c);
    }

    Manifest::
    ~Manifest ()
    {
    }

    // Version
    //

    Version::
    Version (const ::xercesc::DOMElement& e,
             ::xml_schema::Flags f,
             ::xml_schema::Container* c)
    : ::xml_schema::Token (e, f, c)
    {
      _xsd_Version_convert ();
    }

    Version::
    Version (const ::xercesc::DOMAttr& a,
             ::xml_schema::Flags f,
             ::xml_schema::Container* c)
    : ::xml_schema::Token (a, f, c)
    {
      _xsd_Version_convert ();
    }

    Version::
    Version (const ::std::string& s,
             const ::xercesc::DOMElement* e,
             ::xml_schema::Flags f,
             ::xml_schema::Container* c)
    : ::xml_schema::Token (s, e, f, c)
    {
      _xsd_Version_convert ();
    }

    Version* Version::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Version (*this, f, c);
    }

    Version::Value Version::
    _xsd_Version_convert () const
    {
      ::xsd::cxx::tree::enum_comparator< char > c (_xsd_Version_literals_);
      const Value* i (::std::lower_bound (
                        _xsd_Version_indexes_,
                        _xsd_Version_indexes_ + 1,
                        *this,
                        c));

      if (i == _xsd_Version_indexes_ + 1 || _xsd_Version_literals_[*i] != *this)
      {
        throw ::xsd::cxx::tree::unexpected_enumerator < char > (*this);
      }

      return *i;
    }

    const char* const Version::
    _xsd_Version_literals_[1] =
    {
      "1.2"
    };

    const Version::Value Version::
    _xsd_Version_indexes_[1] =
    {
      ::digidoc::manifest_1_2::Version::cxx_1_2
    };

    // File_entry
    //

    File_entry::
    File_entry (const Full_pathType& full_path,
                const Media_typeType& media_type)
    : ::xml_schema::Type (),
      encryption_data_ (this),
      full_path_ (full_path, this),
      size_ (this),
      media_type_ (media_type, this),
      preferred_view_mode_ (this),
      version_ (this)
    {
    }

    File_entry::
    File_entry (const File_entry& x,
                ::xml_schema::Flags f,
                ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      encryption_data_ (x.encryption_data_, f, this),
      full_path_ (x.full_path_, f, this),
      size_ (x.size_, f, this),
      media_type_ (x.media_type_, f, this),
      preferred_view_mode_ (x.preferred_view_mode_, f, this),
      version_ (x.version_, f, this)
    {
    }

    File_entry::
    File_entry (const ::xercesc::DOMElement& e,
                ::xml_schema::Flags f,
                ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      encryption_data_ (this),
      full_path_ (this),
      size_ (this),
      media_type_ (this),
      preferred_view_mode_ (this),
      version_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
        this->parse (p, f);
      }
    }

    void File_entry::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // encryption-data
        //
        if (n.name () == "encryption-data" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          ::std::unique_ptr< Encryption_dataType > r (
            Encryption_dataTraits::create (i, f, this));

          if (!this->encryption_data_)
          {
            this->encryption_data_.set (::std::move (r));
            continue;
          }
        }

        break;
      }

      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "full-path" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->full_path_.set (Full_pathTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "size" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->size_.set (SizeTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "media-type" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->media_type_.set (Media_typeTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "preferred-view-mode" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->preferred_view_mode_.set (Preferred_view_modeTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "version" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->version_.set (VersionTraits::create (i, f, this));
          continue;
        }
      }

      if (!full_path_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "full-path",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }

      if (!media_type_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "media-type",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }
    }

    File_entry* File_entry::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class File_entry (*this, f, c);
    }

    File_entry::
    ~File_entry ()
    {
    }

    // Preferred_view_mode
    //

    Preferred_view_mode::
    Preferred_view_mode (const ::xercesc::DOMElement& e,
                         ::xml_schema::Flags f,
                         ::xml_schema::Container* c)
    : ::xml_schema::String (e, f, c)
    {
    }

    Preferred_view_mode::
    Preferred_view_mode (const ::xercesc::DOMAttr& a,
                         ::xml_schema::Flags f,
                         ::xml_schema::Container* c)
    : ::xml_schema::String (a, f, c)
    {
    }

    Preferred_view_mode::
    Preferred_view_mode (const ::std::string& s,
                         const ::xercesc::DOMElement* e,
                         ::xml_schema::Flags f,
                         ::xml_schema::Container* c)
    : ::xml_schema::String (s, e, f, c)
    {
    }

    Preferred_view_mode* Preferred_view_mode::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Preferred_view_mode (*this, f, c);
    }

    // Encryption_data
    //

    Encryption_data::
    Encryption_data (const AlgorithmType& algorithm,
                     const Key_derivationType& key_derivation,
                     const Checksum_typeType& checksum_type,
                     const ChecksumType& checksum)
    : ::xml_schema::Type (),
      algorithm_ (algorithm, this),
      start_key_generation_ (this),
      key_derivation_ (key_derivation, this),
      checksum_type_ (checksum_type, this),
      checksum_ (checksum, this)
    {
    }

    Encryption_data::
    Encryption_data (::std::unique_ptr< AlgorithmType > algorithm,
                     ::std::unique_ptr< Key_derivationType > key_derivation,
                     const Checksum_typeType& checksum_type,
                     const ChecksumType& checksum)
    : ::xml_schema::Type (),
      algorithm_ (std::move (algorithm), this),
      start_key_generation_ (this),
      key_derivation_ (std::move (key_derivation), this),
      checksum_type_ (checksum_type, this),
      checksum_ (checksum, this)
    {
    }

    Encryption_data::
    Encryption_data (const Encryption_data& x,
                     ::xml_schema::Flags f,
                     ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      algorithm_ (x.algorithm_, f, this),
      start_key_generation_ (x.start_key_generation_, f, this),
      key_derivation_ (x.key_derivation_, f, this),
      checksum_type_ (x.checksum_type_, f, this),
      checksum_ (x.checksum_, f, this)
    {
    }

    Encryption_data::
    Encryption_data (const ::xercesc::DOMElement& e,
                     ::xml_schema::Flags f,
                     ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      algorithm_ (this),
      start_key_generation_ (this),
      key_derivation_ (this),
      checksum_type_ (this),
      checksum_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
        this->parse (p, f);
      }
    }

    void Encryption_data::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // algorithm
        //
        if (n.name () == "algorithm" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          ::std::unique_ptr< AlgorithmType > r (
            AlgorithmTraits::create (i, f, this));

          if (!algorithm_.present ())
          {
            this->algorithm_.set (::std::move (r));
            continue;
          }
        }

        // start-key-generation
        //
        if (n.name () == "start-key-generation" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          ::std::unique_ptr< Start_key_generationType > r (
            Start_key_generationTraits::create (i, f, this));

          if (!this->start_key_generation_)
          {
            this->start_key_generation_.set (::std::move (r));
            continue;
          }
        }

        // key-derivation
        //
        if (n.name () == "key-derivation" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          ::std::unique_ptr< Key_derivationType > r (
            Key_derivationTraits::create (i, f, this));

          if (!key_derivation_.present ())
          {
            this->key_derivation_.set (::std::move (r));
            continue;
          }
        }

        break;
      }

      if (!algorithm_.present ())
      {
        throw ::xsd::cxx::tree::expected_element< char > (
          "algorithm",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }

      if (!key_derivation_.present ())
      {
        throw ::xsd::cxx::tree::expected_element< char > (
          "key-derivation",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }

      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "checksum-type" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->checksum_type_.set (Checksum_typeTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "checksum" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->checksum_.set (ChecksumTraits::create (i, f, this));
          continue;
        }
      }

      if (!checksum_type_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "checksum-type",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }

      if (!checksum_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "checksum",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }
    }

    Encryption_data* Encryption_data::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Encryption_data (*this, f, c);
    }

    Encryption_data::
    ~Encryption_data ()
    {
    }

    // Checksum_type
    //

    Checksum_type::
    Checksum_type (const ::xercesc::DOMElement& e,
                   ::xml_schema::Flags f,
                   ::xml_schema::Container* c)
    : ::xml_schema::String (e, f, c)
    {
    }

    Checksum_type::
    Checksum_type (const ::xercesc::DOMAttr& a,
                   ::xml_schema::Flags f,
                   ::xml_schema::Container* c)
    : ::xml_schema::String (a, f, c)
    {
    }

    Checksum_type::
    Checksum_type (const ::std::string& s,
                   const ::xercesc::DOMElement* e,
                   ::xml_schema::Flags f,
                   ::xml_schema::Container* c)
    : ::xml_schema::String (s, e, f, c)
    {
    }

    Checksum_type* Checksum_type::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Checksum_type (*this, f, c);
    }

    // Algorithm
    //

    Algorithm::
    Algorithm (const Algorithm_nameType& algorithm_name,
               const Initialisation_vectorType& initialisation_vector)
    : ::xml_schema::Type (),
      algorithm_name_ (algorithm_name, this),
      initialisation_vector_ (initialisation_vector, this)
    {
    }

    Algorithm::
    Algorithm (const Algorithm& x,
               ::xml_schema::Flags f,
               ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      algorithm_name_ (x.algorithm_name_, f, this),
      initialisation_vector_ (x.initialisation_vector_, f, this)
    {
    }

    Algorithm::
    Algorithm (const ::xercesc::DOMElement& e,
               ::xml_schema::Flags f,
               ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      algorithm_name_ (this),
      initialisation_vector_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, true);
        this->parse (p, f);
      }
    }

    void Algorithm::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        break;
      }

      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "algorithm-name" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->algorithm_name_.set (Algorithm_nameTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "initialisation-vector" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->initialisation_vector_.set (Initialisation_vectorTraits::create (i, f, this));
          continue;
        }
      }

      if (!algorithm_name_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "algorithm-name",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }

      if (!initialisation_vector_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "initialisation-vector",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }
    }

    Algorithm* Algorithm::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Algorithm (*this, f, c);
    }

    Algorithm::
    ~Algorithm ()
    {
    }

    // Algorithm_name
    //

    Algorithm_name::
    Algorithm_name (const ::xercesc::DOMElement& e,
                    ::xml_schema::Flags f,
                    ::xml_schema::Container* c)
    : ::xml_schema::String (e, f, c)
    {
    }

    Algorithm_name::
    Algorithm_name (const ::xercesc::DOMAttr& a,
                    ::xml_schema::Flags f,
                    ::xml_schema::Container* c)
    : ::xml_schema::String (a, f, c)
    {
    }

    Algorithm_name::
    Algorithm_name (const ::std::string& s,
                    const ::xercesc::DOMElement* e,
                    ::xml_schema::Flags f,
                    ::xml_schema::Container* c)
    : ::xml_schema::String (s, e, f, c)
    {
    }

    Algorithm_name* Algorithm_name::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Algorithm_name (*this, f, c);
    }

    // Key_derivation
    //

    Key_derivation::
    Key_derivation (const Key_derivation_nameType& key_derivation_name,
                    const SaltType& salt,
                    const Iteration_countType& iteration_count)
    : ::xml_schema::Type (),
      key_derivation_name_ (key_derivation_name, this),
      salt_ (salt, this),
      iteration_count_ (iteration_count, this),
      key_size_ (this)
    {
    }

    Key_derivation::
    Key_derivation (const Key_derivation& x,
                    ::xml_schema::Flags f,
                    ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      key_derivation_name_ (x.key_derivation_name_, f, this),
      salt_ (x.salt_, f, this),
      iteration_count_ (x.iteration_count_, f, this),
      key_size_ (x.key_size_, f, this)
    {
    }

    Key_derivation::
    Key_derivation (const ::xercesc::DOMElement& e,
                    ::xml_schema::Flags f,
                    ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      key_derivation_name_ (this),
      salt_ (this),
      iteration_count_ (this),
      key_size_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void Key_derivation::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "key-derivation-name" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->key_derivation_name_.set (Key_derivation_nameTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "salt" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->salt_.set (SaltTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "iteration-count" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->iteration_count_.set (Iteration_countTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "key-size" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->key_size_.set (Key_sizeTraits::create (i, f, this));
          continue;
        }
      }

      if (!key_derivation_name_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "key-derivation-name",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }

      if (!salt_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "salt",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }

      if (!iteration_count_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "iteration-count",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }
    }

    Key_derivation* Key_derivation::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Key_derivation (*this, f, c);
    }

    Key_derivation::
    ~Key_derivation ()
    {
    }

    // Key_derivation_name
    //

    Key_derivation_name::
    Key_derivation_name (const ::xercesc::DOMElement& e,
                         ::xml_schema::Flags f,
                         ::xml_schema::Container* c)
    : ::xml_schema::String (e, f, c)
    {
    }

    Key_derivation_name::
    Key_derivation_name (const ::xercesc::DOMAttr& a,
                         ::xml_schema::Flags f,
                         ::xml_schema::Container* c)
    : ::xml_schema::String (a, f, c)
    {
    }

    Key_derivation_name::
    Key_derivation_name (const ::std::string& s,
                         const ::xercesc::DOMElement* e,
                         ::xml_schema::Flags f,
                         ::xml_schema::Container* c)
    : ::xml_schema::String (s, e, f, c)
    {
    }

    Key_derivation_name* Key_derivation_name::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Key_derivation_name (*this, f, c);
    }

    // Start_key_generation
    //

    Start_key_generation::
    Start_key_generation (const Start_key_generation_nameType& start_key_generation_name)
    : ::xml_schema::Type (),
      start_key_generation_name_ (start_key_generation_name, this),
      key_size_ (this)
    {
    }

    Start_key_generation::
    Start_key_generation (const Start_key_generation& x,
                          ::xml_schema::Flags f,
                          ::xml_schema::Container* c)
    : ::xml_schema::Type (x, f, c),
      start_key_generation_name_ (x.start_key_generation_name_, f, this),
      key_size_ (x.key_size_, f, this)
    {
    }

    Start_key_generation::
    Start_key_generation (const ::xercesc::DOMElement& e,
                          ::xml_schema::Flags f,
                          ::xml_schema::Container* c)
    : ::xml_schema::Type (e, f | ::xml_schema::Flags::base, c),
      start_key_generation_name_ (this),
      key_size_ (this)
    {
      if ((f & ::xml_schema::Flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void Start_key_generation::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::Flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "start-key-generation-name" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->start_key_generation_name_.set (Start_key_generation_nameTraits::create (i, f, this));
          continue;
        }

        if (n.name () == "key-size" && n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
        {
          this->key_size_.set (Key_sizeTraits::create (i, f, this));
          continue;
        }
      }

      if (!start_key_generation_name_.present ())
      {
        throw ::xsd::cxx::tree::expected_attribute< char > (
          "start-key-generation-name",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }
    }

    Start_key_generation* Start_key_generation::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Start_key_generation (*this, f, c);
    }

    Start_key_generation::
    ~Start_key_generation ()
    {
    }

    // Start_key_generation_name
    //

    Start_key_generation_name::
    Start_key_generation_name (const ::xercesc::DOMElement& e,
                               ::xml_schema::Flags f,
                               ::xml_schema::Container* c)
    : ::xml_schema::String (e, f, c)
    {
    }

    Start_key_generation_name::
    Start_key_generation_name (const ::xercesc::DOMAttr& a,
                               ::xml_schema::Flags f,
                               ::xml_schema::Container* c)
    : ::xml_schema::String (a, f, c)
    {
    }

    Start_key_generation_name::
    Start_key_generation_name (const ::std::string& s,
                               const ::xercesc::DOMElement* e,
                               ::xml_schema::Flags f,
                               ::xml_schema::Container* c)
    : ::xml_schema::String (s, e, f, c)
    {
    }

    Start_key_generation_name* Start_key_generation_name::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Start_key_generation_name (*this, f, c);
    }

    // Preferred_view_mode_member
    //

    Preferred_view_mode_member::
    Preferred_view_mode_member (const ::xercesc::DOMElement& e,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Token (e, f, c)
    {
      _xsd_Preferred_view_mode_member_convert ();
    }

    Preferred_view_mode_member::
    Preferred_view_mode_member (const ::xercesc::DOMAttr& a,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Token (a, f, c)
    {
      _xsd_Preferred_view_mode_member_convert ();
    }

    Preferred_view_mode_member::
    Preferred_view_mode_member (const ::std::string& s,
                                const ::xercesc::DOMElement* e,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Token (s, e, f, c)
    {
      _xsd_Preferred_view_mode_member_convert ();
    }

    Preferred_view_mode_member* Preferred_view_mode_member::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Preferred_view_mode_member (*this, f, c);
    }

    Preferred_view_mode_member::Value Preferred_view_mode_member::
    _xsd_Preferred_view_mode_member_convert () const
    {
      ::xsd::cxx::tree::enum_comparator< char > c (_xsd_Preferred_view_mode_member_literals_);
      const Value* i (::std::lower_bound (
                        _xsd_Preferred_view_mode_member_indexes_,
                        _xsd_Preferred_view_mode_member_indexes_ + 1,
                        *this,
                        c));

      if (i == _xsd_Preferred_view_mode_member_indexes_ + 1 || _xsd_Preferred_view_mode_member_literals_[*i] != *this)
      {
        throw ::xsd::cxx::tree::unexpected_enumerator < char > (*this);
      }

      return *i;
    }

    const char* const Preferred_view_mode_member::
    _xsd_Preferred_view_mode_member_literals_[1] =
    {
      "edit"
    };

    const Preferred_view_mode_member::Value Preferred_view_mode_member::
    _xsd_Preferred_view_mode_member_indexes_[1] =
    {
      ::digidoc::manifest_1_2::Preferred_view_mode_member::edit
    };

    // Preferred_view_mode_member1
    //

    Preferred_view_mode_member1::
    Preferred_view_mode_member1 (const ::xercesc::DOMElement& e,
                                 ::xml_schema::Flags f,
                                 ::xml_schema::Container* c)
    : ::xml_schema::Token (e, f, c)
    {
      _xsd_Preferred_view_mode_member1_convert ();
    }

    Preferred_view_mode_member1::
    Preferred_view_mode_member1 (const ::xercesc::DOMAttr& a,
                                 ::xml_schema::Flags f,
                                 ::xml_schema::Container* c)
    : ::xml_schema::Token (a, f, c)
    {
      _xsd_Preferred_view_mode_member1_convert ();
    }

    Preferred_view_mode_member1::
    Preferred_view_mode_member1 (const ::std::string& s,
                                 const ::xercesc::DOMElement* e,
                                 ::xml_schema::Flags f,
                                 ::xml_schema::Container* c)
    : ::xml_schema::Token (s, e, f, c)
    {
      _xsd_Preferred_view_mode_member1_convert ();
    }

    Preferred_view_mode_member1* Preferred_view_mode_member1::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Preferred_view_mode_member1 (*this, f, c);
    }

    Preferred_view_mode_member1::Value Preferred_view_mode_member1::
    _xsd_Preferred_view_mode_member1_convert () const
    {
      ::xsd::cxx::tree::enum_comparator< char > c (_xsd_Preferred_view_mode_member1_literals_);
      const Value* i (::std::lower_bound (
                        _xsd_Preferred_view_mode_member1_indexes_,
                        _xsd_Preferred_view_mode_member1_indexes_ + 1,
                        *this,
                        c));

      if (i == _xsd_Preferred_view_mode_member1_indexes_ + 1 || _xsd_Preferred_view_mode_member1_literals_[*i] != *this)
      {
        throw ::xsd::cxx::tree::unexpected_enumerator < char > (*this);
      }

      return *i;
    }

    const char* const Preferred_view_mode_member1::
    _xsd_Preferred_view_mode_member1_literals_[1] =
    {
      "presentation-slide-show"
    };

    const Preferred_view_mode_member1::Value Preferred_view_mode_member1::
    _xsd_Preferred_view_mode_member1_indexes_[1] =
    {
      ::digidoc::manifest_1_2::Preferred_view_mode_member1::presentation_slide_show
    };

    // Preferred_view_mode_member2
    //

    Preferred_view_mode_member2::
    Preferred_view_mode_member2 (const ::xercesc::DOMElement& e,
                                 ::xml_schema::Flags f,
                                 ::xml_schema::Container* c)
    : ::xml_schema::Token (e, f, c)
    {
      _xsd_Preferred_view_mode_member2_convert ();
    }

    Preferred_view_mode_member2::
    Preferred_view_mode_member2 (const ::xercesc::DOMAttr& a,
                                 ::xml_schema::Flags f,
                                 ::xml_schema::Container* c)
    : ::xml_schema::Token (a, f, c)
    {
      _xsd_Preferred_view_mode_member2_convert ();
    }

    Preferred_view_mode_member2::
    Preferred_view_mode_member2 (const ::std::string& s,
                                 const ::xercesc::DOMElement* e,
                                 ::xml_schema::Flags f,
                                 ::xml_schema::Container* c)
    : ::xml_schema::Token (s, e, f, c)
    {
      _xsd_Preferred_view_mode_member2_convert ();
    }

    Preferred_view_mode_member2* Preferred_view_mode_member2::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Preferred_view_mode_member2 (*this, f, c);
    }

    Preferred_view_mode_member2::Value Preferred_view_mode_member2::
    _xsd_Preferred_view_mode_member2_convert () const
    {
      ::xsd::cxx::tree::enum_comparator< char > c (_xsd_Preferred_view_mode_member2_literals_);
      const Value* i (::std::lower_bound (
                        _xsd_Preferred_view_mode_member2_indexes_,
                        _xsd_Preferred_view_mode_member2_indexes_ + 1,
                        *this,
                        c));

      if (i == _xsd_Preferred_view_mode_member2_indexes_ + 1 || _xsd_Preferred_view_mode_member2_literals_[*i] != *this)
      {
        throw ::xsd::cxx::tree::unexpected_enumerator < char > (*this);
      }

      return *i;
    }

    const char* const Preferred_view_mode_member2::
    _xsd_Preferred_view_mode_member2_literals_[1] =
    {
      "read-only"
    };

    const Preferred_view_mode_member2::Value Preferred_view_mode_member2::
    _xsd_Preferred_view_mode_member2_indexes_[1] =
    {
      ::digidoc::manifest_1_2::Preferred_view_mode_member2::read_only
    };

    // Checksum_type_member
    //

    Checksum_type_member::
    Checksum_type_member (const ::xercesc::DOMElement& e,
                          ::xml_schema::Flags f,
                          ::xml_schema::Container* c)
    : ::xml_schema::Token (e, f, c)
    {
      _xsd_Checksum_type_member_convert ();
    }

    Checksum_type_member::
    Checksum_type_member (const ::xercesc::DOMAttr& a,
                          ::xml_schema::Flags f,
                          ::xml_schema::Container* c)
    : ::xml_schema::Token (a, f, c)
    {
      _xsd_Checksum_type_member_convert ();
    }

    Checksum_type_member::
    Checksum_type_member (const ::std::string& s,
                          const ::xercesc::DOMElement* e,
                          ::xml_schema::Flags f,
                          ::xml_schema::Container* c)
    : ::xml_schema::Token (s, e, f, c)
    {
      _xsd_Checksum_type_member_convert ();
    }

    Checksum_type_member* Checksum_type_member::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Checksum_type_member (*this, f, c);
    }

    Checksum_type_member::Value Checksum_type_member::
    _xsd_Checksum_type_member_convert () const
    {
      ::xsd::cxx::tree::enum_comparator< char > c (_xsd_Checksum_type_member_literals_);
      const Value* i (::std::lower_bound (
                        _xsd_Checksum_type_member_indexes_,
                        _xsd_Checksum_type_member_indexes_ + 1,
                        *this,
                        c));

      if (i == _xsd_Checksum_type_member_indexes_ + 1 || _xsd_Checksum_type_member_literals_[*i] != *this)
      {
        throw ::xsd::cxx::tree::unexpected_enumerator < char > (*this);
      }

      return *i;
    }

    const char* const Checksum_type_member::
    _xsd_Checksum_type_member_literals_[1] =
    {
      "SHA1/1K"
    };

    const Checksum_type_member::Value Checksum_type_member::
    _xsd_Checksum_type_member_indexes_[1] =
    {
      ::digidoc::manifest_1_2::Checksum_type_member::SHA1_1K
    };

    // Algorithm_name_member
    //

    Algorithm_name_member::
    Algorithm_name_member (const ::xercesc::DOMElement& e,
                           ::xml_schema::Flags f,
                           ::xml_schema::Container* c)
    : ::xml_schema::Token (e, f, c)
    {
      _xsd_Algorithm_name_member_convert ();
    }

    Algorithm_name_member::
    Algorithm_name_member (const ::xercesc::DOMAttr& a,
                           ::xml_schema::Flags f,
                           ::xml_schema::Container* c)
    : ::xml_schema::Token (a, f, c)
    {
      _xsd_Algorithm_name_member_convert ();
    }

    Algorithm_name_member::
    Algorithm_name_member (const ::std::string& s,
                           const ::xercesc::DOMElement* e,
                           ::xml_schema::Flags f,
                           ::xml_schema::Container* c)
    : ::xml_schema::Token (s, e, f, c)
    {
      _xsd_Algorithm_name_member_convert ();
    }

    Algorithm_name_member* Algorithm_name_member::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Algorithm_name_member (*this, f, c);
    }

    Algorithm_name_member::Value Algorithm_name_member::
    _xsd_Algorithm_name_member_convert () const
    {
      ::xsd::cxx::tree::enum_comparator< char > c (_xsd_Algorithm_name_member_literals_);
      const Value* i (::std::lower_bound (
                        _xsd_Algorithm_name_member_indexes_,
                        _xsd_Algorithm_name_member_indexes_ + 1,
                        *this,
                        c));

      if (i == _xsd_Algorithm_name_member_indexes_ + 1 || _xsd_Algorithm_name_member_literals_[*i] != *this)
      {
        throw ::xsd::cxx::tree::unexpected_enumerator < char > (*this);
      }

      return *i;
    }

    const char* const Algorithm_name_member::
    _xsd_Algorithm_name_member_literals_[1] =
    {
      "Blowfish CFB"
    };

    const Algorithm_name_member::Value Algorithm_name_member::
    _xsd_Algorithm_name_member_indexes_[1] =
    {
      ::digidoc::manifest_1_2::Algorithm_name_member::Blowfish_CFB
    };

    // Key_derivation_name_member
    //

    Key_derivation_name_member::
    Key_derivation_name_member (const ::xercesc::DOMElement& e,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Token (e, f, c)
    {
      _xsd_Key_derivation_name_member_convert ();
    }

    Key_derivation_name_member::
    Key_derivation_name_member (const ::xercesc::DOMAttr& a,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Token (a, f, c)
    {
      _xsd_Key_derivation_name_member_convert ();
    }

    Key_derivation_name_member::
    Key_derivation_name_member (const ::std::string& s,
                                const ::xercesc::DOMElement* e,
                                ::xml_schema::Flags f,
                                ::xml_schema::Container* c)
    : ::xml_schema::Token (s, e, f, c)
    {
      _xsd_Key_derivation_name_member_convert ();
    }

    Key_derivation_name_member* Key_derivation_name_member::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Key_derivation_name_member (*this, f, c);
    }

    Key_derivation_name_member::Value Key_derivation_name_member::
    _xsd_Key_derivation_name_member_convert () const
    {
      ::xsd::cxx::tree::enum_comparator< char > c (_xsd_Key_derivation_name_member_literals_);
      const Value* i (::std::lower_bound (
                        _xsd_Key_derivation_name_member_indexes_,
                        _xsd_Key_derivation_name_member_indexes_ + 1,
                        *this,
                        c));

      if (i == _xsd_Key_derivation_name_member_indexes_ + 1 || _xsd_Key_derivation_name_member_literals_[*i] != *this)
      {
        throw ::xsd::cxx::tree::unexpected_enumerator < char > (*this);
      }

      return *i;
    }

    const char* const Key_derivation_name_member::
    _xsd_Key_derivation_name_member_literals_[1] =
    {
      "PBKDF2"
    };

    const Key_derivation_name_member::Value Key_derivation_name_member::
    _xsd_Key_derivation_name_member_indexes_[1] =
    {
      ::digidoc::manifest_1_2::Key_derivation_name_member::PBKDF2
    };

    // Start_key_generation_name_member
    //

    Start_key_generation_name_member::
    Start_key_generation_name_member (const ::xercesc::DOMElement& e,
                                      ::xml_schema::Flags f,
                                      ::xml_schema::Container* c)
    : ::xml_schema::Token (e, f, c)
    {
      _xsd_Start_key_generation_name_member_convert ();
    }

    Start_key_generation_name_member::
    Start_key_generation_name_member (const ::xercesc::DOMAttr& a,
                                      ::xml_schema::Flags f,
                                      ::xml_schema::Container* c)
    : ::xml_schema::Token (a, f, c)
    {
      _xsd_Start_key_generation_name_member_convert ();
    }

    Start_key_generation_name_member::
    Start_key_generation_name_member (const ::std::string& s,
                                      const ::xercesc::DOMElement* e,
                                      ::xml_schema::Flags f,
                                      ::xml_schema::Container* c)
    : ::xml_schema::Token (s, e, f, c)
    {
      _xsd_Start_key_generation_name_member_convert ();
    }

    Start_key_generation_name_member* Start_key_generation_name_member::
    _clone (::xml_schema::Flags f,
            ::xml_schema::Container* c) const
    {
      return new class Start_key_generation_name_member (*this, f, c);
    }

    Start_key_generation_name_member::Value Start_key_generation_name_member::
    _xsd_Start_key_generation_name_member_convert () const
    {
      ::xsd::cxx::tree::enum_comparator< char > c (_xsd_Start_key_generation_name_member_literals_);
      const Value* i (::std::lower_bound (
                        _xsd_Start_key_generation_name_member_indexes_,
                        _xsd_Start_key_generation_name_member_indexes_ + 1,
                        *this,
                        c));

      if (i == _xsd_Start_key_generation_name_member_indexes_ + 1 || _xsd_Start_key_generation_name_member_literals_[*i] != *this)
      {
        throw ::xsd::cxx::tree::unexpected_enumerator < char > (*this);
      }

      return *i;
    }

    const char* const Start_key_generation_name_member::
    _xsd_Start_key_generation_name_member_literals_[1] =
    {
      "SHA1"
    };

    const Start_key_generation_name_member::Value Start_key_generation_name_member::
    _xsd_Start_key_generation_name_member_indexes_[1] =
    {
      ::digidoc::manifest_1_2::Start_key_generation_name_member::SHA1
    };
  }
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace digidoc
{
  namespace manifest_1_2
  {
    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (const ::std::string& u,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest > (
        ::digidoc::manifest_1_2::manifest (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (const ::std::string& u,
              ::xml_schema::ErrorHandler& h,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest > (
        ::digidoc::manifest_1_2::manifest (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (const ::std::string& u,
              ::xercesc::DOMErrorHandler& h,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest > (
        ::digidoc::manifest_1_2::manifest (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::digidoc::manifest_1_2::manifest (isrc, f, p);
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              ::xml_schema::ErrorHandler& h,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::digidoc::manifest_1_2::manifest (isrc, h, f, p);
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              ::xercesc::DOMErrorHandler& h,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::digidoc::manifest_1_2::manifest (isrc, h, f, p);
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              const ::std::string& sid,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::digidoc::manifest_1_2::manifest (isrc, f, p);
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              const ::std::string& sid,
              ::xml_schema::ErrorHandler& h,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0,
        (f & ::xml_schema::Flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::digidoc::manifest_1_2::manifest (isrc, h, f, p);
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::std::istream& is,
              const ::std::string& sid,
              ::xercesc::DOMErrorHandler& h,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::digidoc::manifest_1_2::manifest (isrc, h, f, p);
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::xercesc::InputSource& i,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest > (
        ::digidoc::manifest_1_2::manifest (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::xercesc::InputSource& i,
              ::xml_schema::ErrorHandler& h,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest > (
        ::digidoc::manifest_1_2::manifest (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::xercesc::InputSource& i,
              ::xercesc::DOMErrorHandler& h,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest > (
        ::digidoc::manifest_1_2::manifest (
          std::move (d), f | ::xml_schema::Flags::own_dom, p));
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (const ::xercesc::DOMDocument& doc,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties& p)
    {
      if (f & ::xml_schema::Flags::keep_dom)
      {
        ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
          static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

        return ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest > (
          ::digidoc::manifest_1_2::manifest (
            std::move (d), f | ::xml_schema::Flags::own_dom, p));
      }

      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "manifest" &&
          n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
      {
        ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest > r (
          ::xsd::cxx::tree::traits< ::digidoc::manifest_1_2::Manifest, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "manifest",
        "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
    }

    ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest >
    manifest (::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d,
              ::xml_schema::Flags f,
              const ::xml_schema::Properties&)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > c (
        ((f & ::xml_schema::Flags::keep_dom) &&
         !(f & ::xml_schema::Flags::own_dom))
        ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
        : 0);

      ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (f & ::xml_schema::Flags::keep_dom)
        doc.setUserData (::xml_schema::dom::treeNodeKey,
                         (c.get () ? &c : &d),
                         0);

      if (n.name () == "manifest" &&
          n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
      {
        ::std::unique_ptr< ::digidoc::manifest_1_2::Manifest > r (
          ::xsd::cxx::tree::traits< ::digidoc::manifest_1_2::Manifest, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "manifest",
        "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
    }
  }
}

#include <ostream>
#include <xsd/cxx/tree/error-handler.hxx>
#include <xsd/cxx/xml/dom/serialization-source.hxx>

namespace digidoc
{
  namespace manifest_1_2
  {
    void
    manifest (::std::ostream& o,
              const ::digidoc::manifest_1_2::Manifest& s,
              const ::xml_schema::NamespaceInfomap& m,
              const ::std::string& e,
              ::xml_schema::Flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0);

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::digidoc::manifest_1_2::manifest (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    manifest (::std::ostream& o,
              const ::digidoc::manifest_1_2::Manifest& s,
              ::xml_schema::ErrorHandler& h,
              const ::xml_schema::NamespaceInfomap& m,
              const ::std::string& e,
              ::xml_schema::Flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::Flags::dont_initialize) == 0);

      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::digidoc::manifest_1_2::manifest (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    manifest (::std::ostream& o,
              const ::digidoc::manifest_1_2::Manifest& s,
              ::xercesc::DOMErrorHandler& h,
              const ::xml_schema::NamespaceInfomap& m,
              const ::std::string& e,
              ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::digidoc::manifest_1_2::manifest (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    manifest (::xercesc::XMLFormatTarget& t,
              const ::digidoc::manifest_1_2::Manifest& s,
              const ::xml_schema::NamespaceInfomap& m,
              const ::std::string& e,
              ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::digidoc::manifest_1_2::manifest (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    manifest (::xercesc::XMLFormatTarget& t,
              const ::digidoc::manifest_1_2::Manifest& s,
              ::xml_schema::ErrorHandler& h,
              const ::xml_schema::NamespaceInfomap& m,
              const ::std::string& e,
              ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::digidoc::manifest_1_2::manifest (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    manifest (::xercesc::XMLFormatTarget& t,
              const ::digidoc::manifest_1_2::Manifest& s,
              ::xercesc::DOMErrorHandler& h,
              const ::xml_schema::NamespaceInfomap& m,
              const ::std::string& e,
              ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::digidoc::manifest_1_2::manifest (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    manifest (::xercesc::DOMDocument& d,
              const ::digidoc::manifest_1_2::Manifest& s,
              ::xml_schema::Flags)
    {
      ::xercesc::DOMElement& e (*d.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "manifest" &&
          n.namespace_ () == "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0")
      {
        e << s;
      }
      else
      {
        throw ::xsd::cxx::tree::unexpected_element < char > (
          n.name (),
          n.namespace_ (),
          "manifest",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");
      }
    }

    ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument >
    manifest (const ::digidoc::manifest_1_2::Manifest& s,
              const ::xml_schema::NamespaceInfomap& m,
              ::xml_schema::Flags f)
    {
      ::xml_schema::dom::unique_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::serialize< char > (
          "manifest",
          "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
          m, f));

      ::digidoc::manifest_1_2::manifest (*d, s, f);
      return d;
    }

    void
    operator<< (::xercesc::DOMElement& e, const Base64Binary& i)
    {
      e << static_cast< const ::xml_schema::Base64Binary& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Base64Binary& i)
    {
      a << static_cast< const ::xml_schema::Base64Binary& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Base64Binary& i)
    {
      l << static_cast< const ::xml_schema::Base64Binary& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const NamespacedToken& i)
    {
      e << static_cast< const ::xml_schema::Qname& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const NamespacedToken& i)
    {
      a << static_cast< const ::xml_schema::Qname& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const NamespacedToken& i)
    {
      l << static_cast< const ::xml_schema::Qname& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const NonNegativeInteger& i)
    {
      e << static_cast< const ::xsd::cxx::tree::fundamental_base< ::xml_schema::NonNegativeInteger, char, ::xml_schema::SimpleType >& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const NonNegativeInteger& i)
    {
      a << static_cast< const ::xsd::cxx::tree::fundamental_base< ::xml_schema::NonNegativeInteger, char, ::xml_schema::SimpleType >& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const NonNegativeInteger& i)
    {
      l << static_cast< const ::xsd::cxx::tree::fundamental_base< ::xml_schema::NonNegativeInteger, char, ::xml_schema::SimpleType >& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const String& i)
    {
      e << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const String& i)
    {
      a << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const String& i)
    {
      l << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const AnyURI& i)
    {
      e << static_cast< const ::xml_schema::Uri& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const AnyURI& i)
    {
      a << static_cast< const ::xml_schema::Uri& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const AnyURI& i)
    {
      l << static_cast< const ::xml_schema::Uri& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Manifest& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // file-entry
      //
      for (Manifest::File_entryConstIterator
           b (i.file_entry ().begin ()), n (i.file_entry ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "file-entry",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        s << *b;
      }

      // version
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "version",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.version ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const Version& i)
    {
      e << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Version& i)
    {
      a << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Version& i)
    {
      l << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const File_entry& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // encryption-data
      //
      if (i.encryption_data ())
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "encryption-data",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        s << *i.encryption_data ();
      }

      // full-path
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "full-path",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.full_path ();
      }

      // size
      //
      if (i.size ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "size",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << *i.size ();
      }

      // media-type
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "media-type",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.media_type ();
      }

      // preferred-view-mode
      //
      if (i.preferred_view_mode ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "preferred-view-mode",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << *i.preferred_view_mode ();
      }

      // version
      //
      if (i.version ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "version",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << *i.version ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const Preferred_view_mode& i)
    {
      e << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Preferred_view_mode& i)
    {
      a << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Preferred_view_mode& i)
    {
      l << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Encryption_data& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // algorithm
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "algorithm",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        s << i.algorithm ();
      }

      // start-key-generation
      //
      if (i.start_key_generation ())
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "start-key-generation",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        s << *i.start_key_generation ();
      }

      // key-derivation
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "key-derivation",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        s << i.key_derivation ();
      }

      // checksum-type
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "checksum-type",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.checksum_type ();
      }

      // checksum
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "checksum",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.checksum ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const Checksum_type& i)
    {
      e << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Checksum_type& i)
    {
      a << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Checksum_type& i)
    {
      l << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Algorithm& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // algorithm-name
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "algorithm-name",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.algorithm_name ();
      }

      // initialisation-vector
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "initialisation-vector",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.initialisation_vector ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const Algorithm_name& i)
    {
      e << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Algorithm_name& i)
    {
      a << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Algorithm_name& i)
    {
      l << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Key_derivation& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // key-derivation-name
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "key-derivation-name",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.key_derivation_name ();
      }

      // salt
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "salt",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.salt ();
      }

      // iteration-count
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "iteration-count",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.iteration_count ();
      }

      // key-size
      //
      if (i.key_size ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "key-size",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << *i.key_size ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const Key_derivation_name& i)
    {
      e << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Key_derivation_name& i)
    {
      a << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Key_derivation_name& i)
    {
      l << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Start_key_generation& i)
    {
      e << static_cast< const ::xml_schema::Type& > (i);

      // start-key-generation-name
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "start-key-generation-name",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << i.start_key_generation_name ();
      }

      // key-size
      //
      if (i.key_size ())
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "key-size",
            "urn:oasis:names:tc:opendocument:xmlns:manifest:1.0",
            e));

        a << *i.key_size ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const Start_key_generation_name& i)
    {
      e << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Start_key_generation_name& i)
    {
      a << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Start_key_generation_name& i)
    {
      l << static_cast< const ::xml_schema::String& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Preferred_view_mode_member& i)
    {
      e << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Preferred_view_mode_member& i)
    {
      a << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Preferred_view_mode_member& i)
    {
      l << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Preferred_view_mode_member1& i)
    {
      e << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Preferred_view_mode_member1& i)
    {
      a << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Preferred_view_mode_member1& i)
    {
      l << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Preferred_view_mode_member2& i)
    {
      e << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Preferred_view_mode_member2& i)
    {
      a << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Preferred_view_mode_member2& i)
    {
      l << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Checksum_type_member& i)
    {
      e << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Checksum_type_member& i)
    {
      a << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Checksum_type_member& i)
    {
      l << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Algorithm_name_member& i)
    {
      e << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Algorithm_name_member& i)
    {
      a << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Algorithm_name_member& i)
    {
      l << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Key_derivation_name_member& i)
    {
      e << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Key_derivation_name_member& i)
    {
      a << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Key_derivation_name_member& i)
    {
      l << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMElement& e, const Start_key_generation_name_member& i)
    {
      e << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xercesc::DOMAttr& a, const Start_key_generation_name_member& i)
    {
      a << static_cast< const ::xml_schema::Token& > (i);
    }

    void
    operator<< (::xml_schema::ListStream& l,
                const Start_key_generation_name_member& i)
    {
      l << static_cast< const ::xml_schema::Token& > (i);
    }
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

